.data

rand_seed1      dd 0
rand_seed2      dd 0
temp            dd 0


.code
;============================================================================
; GetRandom : Pseudo random number generator
;============================================================================
;
; Androgynerator
; an Advanced 32 bits Pseudo Random Number Generator
;  X(n+2) = (A1 * X(n+1) + A2 * X(n) + C) mod M
;
; out
;  eax = random number
;

M           equ 134217729
A1          equ 13
A2          equ 111
C           equ 14449

GetRandom proc

    pushad

    mov eax,dword ptr [rand_seed1]      ;
    mov dword ptr [temp],eax            ;
    mov edx,A1                          ; A1 * RAND_SEED1
    mul edx                             ; le rsultat est dans edx-eax
    mov ebx,eax                         ; on met le rsultat dans ecx-ebx
    mov ecx,edx                         ;
    mov eax,[rand_seed2]                ;
    mov edx,A2                          ; A2 * RAND_SEED2
    mul edx                             ;
    add eax,ebx                         ; on additionne les deux
    adc edx,ecx
    add eax,C                           ; on additionne C
    adc edx,0                           ;
    mov ecx,M                           ; et voil comment on fait
    div ecx                             ; un modulo
    mov eax,edx                         ; on met le rsultat dans ax

    mov dword ptr [rand_seed1],eax      ; on conserve tous les
    mov eax,[temp]                      ; nouveaux rsultats
    mov dword ptr [rand_seed2],eax      ;

    popad

    mov eax, dword ptr [rand_seed1]

    ret                                 ; c'tait vraiment pas dur!

GetRandom endp